import { PageCategory } from './category/Category'
import { Route } from 'react-router-dom';
import { Aside } from '../aside/Aside';
import { CCart } from './cart/Cart';
import { PageGood } from './good/PageGood';
import { CDashboard } from './dashboard/Dashboard';
import { CPRoute } from '../../App';

const Content = ({ children }) =>
    <div className='Content'>
        {children}
    </div>

const PageMain = () => <h2>Главная</h2>




export const Main = () =>
    <main>
        <Aside />
        <Content>
            <Route path='/' component={PageMain} exact />
            <CPRoute roles={['anon', 'user', 'admin']} path="/category/:_id" component={PageCategory} />
            <CPRoute roles={['anon', 'user', 'admin']} path="/good/:_id" component={PageGood} />
            <Route path='/order' component={CCart} />
            <Route path='/dashboard' component={CDashboard} />
        </Content>
    </main>
